<template lang="pug">
    #main
      .container.my-4
        .row
          .col-md-3
            .row.px-2
              .col-md-12.leaderboard.pb-3
                .title.text-center.py-3.bold.underline LEADERBOARD
                .person.py-1.px-2.my-1(:class="`rank-${index+1}`" v-for="(item,key,index) in ranking" )
                  .each-person(v-for="(i,k,x) in item" v-if="x == Object.keys(item).length - 1").d-flex.justify-content-between.align-items-center
                    .display 
                      img.img-fluid(:src="i.profile_url")
                    .name {{i.display_name}}
                    .score {{key}}
          .col-md-7
            .row.playing-section.py-3
              .col-md-12.my-2.text-center
                h4 Current score : {{score}}
              .col-md-12(v-if="finishedGame").text-center
                img.img-fluid(src="https://media.tenor.com/images/314a7ba86e24d67040c417cac74f24fc/tenor.gif")
                h4 ยินดีด้วยคุณคือผู้ชนะ !!
              .col-md-3.my-2.text-center(v-for="(card,index) in cardList")
                  FlipCard(:flip="card.isShow")
                    template(slot="front")
                      div.cardbox.border.rounded-lg(v-on:click="openCard(index)").front
                        | OPEN
                    template(slot="back")
                      div.cardbox.border.rounded-lg(v-if="card.isShow").back
                        span.card-value {{card.value}}
            .row.action
              .col-md-12.text-center.my-3
                b-button.btn.btn-danger.mx-1(v-if="gameStarted" v-on:click="reset") Restart
                //- b-button.btn.btn-danger.mx-1(v-on:click="sendScore") sendScore
          .col-md-2
            .row.px-2
              .col-md-12.leaderboard.pb-3
                div.text-center.py-3.bold.underline
                  | MY BEST SCORE
                .person.py-1.px-2.my-1.small(:class="`rank-${key+1}`" v-for="(item,key,index) in computedMyRank" ).text-center
                  .score {{item.score}}
                  div {{$moment(item.key,"YYYYMDhhmmss").format("MMM Do YY hh:mm")}}
</template>

<script>
import Vue from 'vue'
import _ from "lodash"
import {arrayShuffle , range} from '~/plugins/arrayUtils.js'
import {fireRDB} from '@/plugins/firebase';
import { mapGetters } from "vuex";
import FlipCard from "~/components/FlipCard.vue"
export default {
  name:"Memorygame",
  components:{
    FlipCard
  },
  data:()=>({
    onClicked : false,
    gameInit : process.env.CARD_AMT ? process.env.CARD_AMT : 6,
    foldDuration : 1,
    gameStarted:false,
    score : 0,
    cardList:{},
    myrank:{},
    ranking:{},
    firstClicked : {
      isClicked : false,
      value : '',
      index : ''
    },
    secondClicked : {
      isClicked : false,
      value : '',
      index : ''
    },
  }),
  watch:{
    finishedGame(val){
      if(val)
      {
        this.sendScore()
      }
    },
  },
  computed:{
     ...mapGetters(["isLoggedIn", "stateUser"]),
    finishedGame:function(){
      if(this.countCardLeft == 0 && this.gameStarted)
      {
        return true
      }
      return false
    },
    countCardLeft:function(){
      return _.filter(this.cardList, function(item) {
        return item.isShow === false;
      }).length;
    },
    computedMyRank:function(){
      return _(this.myrank).map(function(v, k) 
            { 
              return _.merge({}, v, { key: k });
            }).sortBy('score').value();
    }
  },
  methods:{
    async sendScore() {
      let res = await this.$axios.post(`${process.env.API_URL}/scores`, {
        "display_name": this.stateUser.displayName,
        "profile_url": this.stateUser.photoURL,
        "user_id": this.stateUser.uid,
        "score": this.score
      },{
        'content-type': 'application/json',
      }).then((resp)=>{
          this.$swal("ยินดีด้วย ท่านคือผู้ชนะ", `ชนะไปด้วยคะแนน ${this.score}`, "success");
      })
    },
    reset(){
      this.start()
      this.resetClickState()
      this.score = 0 
    },
    start(){
      let items = arrayShuffle(this.creatingCardValue(this.gameInit))
      this.gameStarted = true
      Array.from(Array(this.gameInit*2).keys()).forEach((item)=>{
        Vue.set(this.cardList,item,
        {
          value: items.pop(),
          isMatch : false,
          isShow : false
        })
      })
    },
    creatingCardValue(value){
      return range(1, value).concat(range(1, value));
    },
    resetClickState(){
      this.firstClicked = 
      {
        isClicked : false,
        value : '',
        index : ''
      } 
      this.secondClicked = {
        isClicked : false,
        value : '',
        index : ''
      } 
      this.onClicked = true
    },
    async openCard(index){     

      if(!this.firstClicked.isClicked)
      {
        this.firstClicked.isClicked = true
        this.firstCardOpen(index)
        this.score++
      }else if(!this.secondClicked.isClicked)
      {
        this.secondClicked.isClicked = true
        this.secondCardOpen(index)
        this.score++
        await setTimeout(() => {
          if(this.matchingCard()){
            console.log('permanently revale them')
            this.resetClickState()
          }else
          {
            this.cardFold()
            this.resetClickState()
          }
        }, this.foldDuration*1000);
        
      }
    },
    firstCardOpen(index){
      this.firstClicked.value = this.cardList[index].value
      this.firstClicked.index = index
      this.cardList[index].isShow = true
    },
    secondCardOpen(index){
      this.secondClicked.value = this.cardList[index].value
      this.secondClicked.index = index
      this.cardList[index].isShow = true
    },
    matchingCard(){
      if(this.firstClicked.value == this.secondClicked.value)
      {
        return true
      }else{
        return false
      }
    },
    cardFold(){
      this.cardList[this.firstClicked.index].isShow = false
      this.cardList[this.secondClicked.index].isShow = false
    },
  },
  mounted(){
    this.start()
    fireRDB.ref('ranking').orderByKey().limitToFirst(20).on('value', (snapshot) => {
      this.ranking = snapshot.val()
    })
    fireRDB.ref(`history`).child(`${this.stateUser.uid}`).orderByChild('score').limitToFirst(20).on('value', (snapshot) => {
      this.myrank = snapshot.val()
    })
  }
  
}
</script>

<style style="scss" scoped>
.slide-fade-enter-active {
  transition: all .6s ease-in;
}
.slide-fade-leave-active {
  transition: all 1s ease-in-out;
}
.slide-fade-enter, .slide-fade-leave-to
/* .slide-fade-leave-active below version 2.1.8 */ {
  transform: translateX(10px);
  opacity: 0;
}
</style>
